/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using MPLAB(c) Code Configurator

  @Description:
    This header file provides implementations for pin APIs for all pins selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB(c) Code Configurator - 4.0
        Device            :  PIC18F25K50
        Version           :  1.01
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.35
        MPLAB             :  MPLAB X 3.40

    Copyright (c) 2013 - 2015 released Microchip Technology Inc.  All rights reserved.

    Microchip licenses to you the right to use, modify, copy and distribute
    Software only when embedded on a Microchip microcontroller or digital signal
    controller that is integrated into your product or third party product
    (pursuant to the sublicense terms in the accompanying license agreement).

    You should refer to the license agreement accompanying this Software for
    additional information regarding your rights and obligations.

    SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
    EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
    MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
    IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
    CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
    OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
    INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
    CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
    SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
    (INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.

*/


#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set RA4 procedures
#define RA4_SetHigh()    do { LATAbits.LATA4 = 1; } while(0)
#define RA4_SetLow()   do { LATAbits.LATA4 = 0; } while(0)
#define RA4_Toggle()   do { LATAbits.LATA4 = ~LATAbits.LATA4; } while(0)
#define RA4_GetValue()         PORTAbits.RA4
#define RA4_SetDigitalInput()   do { TRISAbits.TRISA4 = 1; } while(0)
#define RA4_SetDigitalOutput()  do { TRISAbits.TRISA4 = 0; } while(0)

// get/set LED_YELLOW aliases
#define LED_YELLOW_TRIS               TRISBbits.TRISB6
#define LED_YELLOW_LAT                LATBbits.LATB6
#define LED_YELLOW_PORT               PORTBbits.RB6
#define LED_YELLOW_WPU                WPUBbits.WPUB6
#define LED_YELLOW_SetHigh()            do { LATBbits.LATB6 = 1; } while(0)
#define LED_YELLOW_SetLow()             do { LATBbits.LATB6 = 0; } while(0)
#define LED_YELLOW_Toggle()             do { LATBbits.LATB6 = ~LATBbits.LATB6; } while(0)
#define LED_YELLOW_GetValue()           PORTBbits.RB6
#define LED_YELLOW_SetDigitalInput()    do { TRISBbits.TRISB6 = 1; } while(0)
#define LED_YELLOW_SetDigitalOutput()   do { TRISBbits.TRISB6 = 0; } while(0)
#define LED_YELLOW_SetPullup()      do { WPUBbits.WPUB6 = 1; } while(0)
#define LED_YELLOW_ResetPullup()    do { WPUBbits.WPUB6 = 0; } while(0)

// get/set LED_GREEN aliases
#define LED_GREEN_TRIS               TRISBbits.TRISB7
#define LED_GREEN_LAT                LATBbits.LATB7
#define LED_GREEN_PORT               PORTBbits.RB7
#define LED_GREEN_WPU                WPUBbits.WPUB7
#define LED_GREEN_SetHigh()            do { LATBbits.LATB7 = 1; } while(0)
#define LED_GREEN_SetLow()             do { LATBbits.LATB7 = 0; } while(0)
#define LED_GREEN_Toggle()             do { LATBbits.LATB7 = ~LATBbits.LATB7; } while(0)
#define LED_GREEN_GetValue()           PORTBbits.RB7
#define LED_GREEN_SetDigitalInput()    do { TRISBbits.TRISB7 = 1; } while(0)
#define LED_GREEN_SetDigitalOutput()   do { TRISBbits.TRISB7 = 0; } while(0)
#define LED_GREEN_SetPullup()      do { WPUBbits.WPUB7 = 1; } while(0)
#define LED_GREEN_ResetPullup()    do { WPUBbits.WPUB7 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/